;LabelSizeOperations.au3


; Адаптирует размеры Label к тексту
Func _ControlAdjust2Text($hWin, $sWinText, $hCtrl, $iPad = 0)
;author: jennico, based on ResNullius, based on PaulIA/GaryFrost (listview udf)
    Local $hWnd, $hDC, $hFont, $iMax, $tSize, $sText, $aCtrlPos, $ctrlX, $ctrlY, $yMax, $GUICtrl=False
    If Not IsHWnd($hCtrl) Then
        $hWnd = GUICtrlGetHandle($hCtrl)
        Switch $hWnd
            Case 0
                $hWnd = ControlGetHandle($hWin, $sWinText, $hCtrl)
            Case Else
                $GUICtrl=True
        EndSwitch
    Else
        $hWnd = $hCtrl
    EndIf
    If IsHWnd($hWnd) Then
        $hFont = _SendMessage($hWnd, $WM_GETFONT)
        $hDC = _WinAPI_GetDC($hWnd)
        _WinAPI_SelectObject($hDC, $hFont)
        Switch $GUICtrl
            Case True
                $sText = GUICtrlRead($hCtrl)
            Case Else
                $sText = ControlGetText($hWin, $sWinText, $hCtrl)
        EndSwitch
        $tSize = _WinAPI_GetTextExtentPoint32($hDC, $sText & " ")
 ;       If DllStructGetData($tSize, "X") > $iMax Then
            $iMax = DllStructGetData($tSize, "X") + $iPad
            $yMax = DllStructGetData($tSize, "Y")
            $aCtrlPos = ControlGetPos($hWin, $sWinText, $hCtrl)
            
            If Not @error Then $ctrlX = $aCtrlPos[0]
            If Not @error Then $ctrlY = $aCtrlPos[1]
    ;        $ctrlW = $aCtrlPos[2]
     ;       $ctrlH = $aCtrlPos[3]
        Switch $GUICtrl
            Case True
                $sText = GUICtrlSetPos($hCtrl,$ctrlX, $ctrlY, $iMax, $yMax)
            Case Else
                ControlMove($hWin, $sWinText, $hCtrl, $ctrlX, $ctrlY, $iMax, $yMax)
        EndSwitch

  ;      EndIf
        _WinAPI_SelectObject($hDC, $hFont)
        _WinAPI_ReleaseDC($hWnd, $hDC)
    EndIf
EndFunc;==>_ControlAdjust2Text

; ============== _GUICtrlCreateLabelEx ========================================================
;$sText -The text of the control.
;$left - The left side of the control
;$top - The top of the control.
;$style - $SS_LEFT, $SS_CENTER, $SS_RIGHT from Label/Static Styles
;$BkGndCol - background color The RGB color to use.
;$size - Fontsize
;$weight - Font weight (default 400 = normal).
;$attribute [optional] To define 0 - Normal weight or thickness 2 underlined:4 strike:
; 8 char format (add together the values of all the styles required, 2+4 = italic and underlined)
;$fontname - The name of the font to use.
;$iPadWidth - Integer, add/substract spaces to string $sText width.
;$iPadHeight - Integer, add/substract spaces to string $sText height.
;$iMultiLineRectWidth - Will cause multi lines if less than width of string, $sText, rectangle (when no @CRLF).
;
Func _GUICtrlCreateLabelEx($sText, $left, $top, $style = $SS_CENTER, $BkGndCol = $GUI_BKCOLOR_TRANSPARENT, $size = 10, _
        $weight = 400, $attribute = 0, $fontname = "Arial", $iPadWidth = 0, $iPadHeight = 0, $iMultiLineRectWidth = @DesktopWidth)

    Local $hWin, $hRetLabel, $hGraphic, $hFamily, $hGDIFont, $hFormat, $tLayout, $aInfo, $hWdith, $hHeight, $bFlag = False
    If StringRegExp($sText, "\x0a|\x0d", 0) = 1 Then
        $aText = StringRegExp($sText, "\w.*[^\x0a|\x0d]", 3)
        Local $MavChar = 0
        For $x = 1 To UBound($aText) - 1
            If StringLen($aText[$x]) > StringLen($aText[$MavChar]) Then $MavChar = $x
        Next
        $sMeasure = $aText[$MavChar]
        $bFlag = True
    Else
        $sMeasure = $sText
    EndIf

    $hWin = WinGetHandle("[ACTIVE]")
    ;_GDIPlus_Startup()
    $hGraphic = _GDIPlus_GraphicsCreateFromHWND($hWin)
    $hFamily = _GDIPlus_FontFamilyCreate($fontname)
    $hGDIFont = _GDIPlus_FontCreate($hFamily, $size, $attribute)
    $hFormat = _GDIPlus_StringFormatCreate()
    $tLayout = _GDIPlus_RectFCreate($left, $top, $iMultiLineRectWidth, @DesktopHeight)
    $aInfo = _GDIPlus_GraphicsMeasureString($hGraphic, $sMeasure, $hGDIFont, $tLayout, $hFormat)
    $hWdith = DllStructGetData($aInfo[0], 3)
    $hHeight = DllStructGetData($aInfo[0], 4)
    If $bFlag Then $hHeight = $hHeight * UBound($aText)
    If Mod($attribute, 2) = 1 Then $attribute = $attribute - 1
    $hRetLabel = GUICtrlCreateLabel($sText, $left, $top, $hWdith + $iPadWidth, $hHeight + $iPadHeight, $style)
    GUICtrlSetBkColor(-1, $BkGndCol)
    GUICtrlSetFont(-1, $size, $weight, $attribute, $fontname)
    _WinAPI_RedrawWindow($hWin, 0, 0, BitOR($RDW_ERASE, $RDW_INVALIDATE, $RDW_UPDATENOW, $RDW_FRAME, $RDW_ALLCHILDREN))
    _GDIPlus_FontDispose($hGDIFont)
    _GDIPlus_FontFamilyDispose($hFamily)
    _GDIPlus_StringFormatDispose($hFormat)
    _GDIPlus_GraphicsDispose($hGraphic)
    ;_GDIPlus_Shutdown()
    Return $hRetLabel
EndFunc   ;==>_GUICtrlCreateLabelEx

; Получает длинну текста
Func getTextLengthInPixel($guiMain, $text, $font, $size = 9, $style = 0)
    ;Calculate actual width of the given text
    ;_GDIPlus_Startup()
    Local $hGraphic = _GDIPlus_GraphicsCreateFromHWND($guiMain)
    Local $hFamily = _GDIPlus_FontFamilyCreate($font)
    Local $hGDIFont = _GDIPlus_FontCreate($hFamily, $size, $style)
    Local $hFormat = _GDIPlus_StringFormatCreate()
    Local $tLayout = _GDIPlus_RectFCreate(0, 0, @DesktopWidth, @DesktopHeight)

    Local $aInfo = _GDIPlus_GraphicsMeasureString($hGraphic, $text, $hGDIFont, $tLayout, $hFormat)
    Local $width = Int(DllStructGetData($aInfo[0], 3)) + 1
    
    _GDIPlus_StringFormatDispose($hFormat)
    _GDIPlus_FontDispose($hGDIFont)
    _GDIPlus_FontFamilyDispose($hFamily)
    _GDIPlus_GraphicsDispose($hGraphic)
    ;_GDIPlus_Shutdown()
    Return $width
EndFunc